<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html><head><meta http-equiv="Content-Type" content="text/html;charset=iso-8859-1">
<title>iCelGameServer Struct Reference (CEL: Crystal Entity Layer 2.0 Public API Reference)</title>
<link href="tabs.css" rel="stylesheet" type="text/css">
<link href="doxygen.css" rel="stylesheet" type="text/css">
</head><body>
<table border="0" cellpadding="0" cellspacing="0" width="100%" class="head">
 <tr height="59">
  <td class="head" width="202" valign="bottom" style="padding-left:0;"><a href="http://cel.crystalspace3d.org/"><img src="celblur.png" width="210" height="59" alt="CEL" border="0"></a></td>
  <td class="head"><h2>Public API Reference</h2></td>
 </tr>
 <tr height="11">
  <td colspan="2" class="headshadow" valign="top" style="padding-left:0;"><img src="celshadow.png" width="9" height="11" alt="" border="0"></td>
 </tr>
</table>
<div class="content">
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="hierarchy.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a>  </div>
  <div class="headertitle">
<div class="title">iCelGameServer Struct Reference</div>  </div>
</div><!--header-->
<div class="contents">
<!-- doxytag: class="iCelGameServer" --><!-- doxytag: inherits="iBase" -->
<p>The main object to manage the server game logic.  
 <a href="structiCelGameServer.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="network_8h_source.html">physicallayer/network.h</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for iCelGameServer:</div>
<div class="dyncontent">
 <div class="center">
  <img src="structiCelGameServer.png" usemap="#iCelGameServer_map" alt=""/>
  <map id="iCelGameServer_map" name="iCelGameServer_map">
<area doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiBase.html" alt="iBase" shape="rect" coords="0,0,105,24"/>
</map>
 </div></div>

<p><a href="structiCelGameServer-members.html">List of all members.</a></p>
<table class="memberdecls">
<tr><td colspan="2"><h2><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiCelGameServer.html#a85aee2cd64948525a312287aca56cc7e">ChangeLevel</a> (<a class="el" href="classcelGameInfo.html">celGameInfo</a> *new_game)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Level change, the game is re-initialized.  <a href="#a85aee2cd64948525a312287aca56cc7e"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiCelGameServer.html#a2226fe2e45a5ed5218fe1902cdf0952c">ChangeLinkControl</a> (<a class="el" href="structiCelEntity.html">iCelEntity</a> *entity, <a class="el" href="classcelPlayer.html">celPlayer</a> *player, bool player_controlled)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Define if it is the client or the server that will update the entity.  <a href="#a2226fe2e45a5ed5218fe1902cdf0952c"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual <a class="el" href="structiCelPlayerList.html">iCelPlayerList</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiCelGameServer.html#ad9f84d3748644041a79a77ffc52b0101">CreateChannel</a> (<a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#gad5ecc59cce16a9f5a796b6e55da62e56">csStringID</a> channel_id)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Create a channel, ie a list of players.  <a href="#ad9f84d3748644041a79a77ffc52b0101"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual <a class="el" href="classcelPlayer.html">celPlayer</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiCelGameServer.html#a2b1eec275a973437b25f4194df7afca3">GetAdministrator</a> ()=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Return the administrator of the game.  <a href="#a2b1eec275a973437b25f4194df7afca3"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiCelGameServer.html#a48175bcad72165ff0d472a12bdad91e0">GetNetworkPlayerStats</a> (<a class="el" href="classcelPlayer.html">celPlayer</a> *player, <a class="el" href="structcelNetworkPlayerStats.html">celNetworkPlayerStats</a> &amp;stats) const =0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Return the network stats of the specified player.  <a href="#a48175bcad72165ff0d472a12bdad91e0"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiCelGameServer.html#af65fd31e91d224e8a7f1d031b0248f0a">GetNetworkTotalStats</a> (<a class="el" href="structcelNetworkPlayerTotalStats.html">celNetworkPlayerTotalStats</a> &amp;stats) const =0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Return the network stats of this server.  <a href="#af65fd31e91d224e8a7f1d031b0248f0a"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual <a class="el" href="structiCelPlayerList.html">iCelPlayerList</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiCelGameServer.html#ac664ae438691d8e81ab1eca933ac8ddf">GetPlayerList</a> ()=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Return the list of players connected to the server.  <a href="#ac664ae438691d8e81ab1eca933ac8ddf"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual celPlayerNetworkState&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiCelGameServer.html#a1fdd2b3ad82217d20ff4ab1e32e9ae00">GetPlayerState</a> (<a class="el" href="classcelPlayer.html">celPlayer</a> *player)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Return the state of the network connection to the player.  <a href="#a1fdd2b3ad82217d20ff4ab1e32e9ae00"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiCelGameServer.html#afbad5b793a8dfffbb3a804cdb61003de">KickPlayer</a> (<a class="el" href="classcelPlayer.html">celPlayer</a> *player, const char *reason)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Kick the player from the game, ie the player will be forced to disconnect from the game.  <a href="#afbad5b793a8dfffbb3a804cdb61003de"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiCelGameServer.html#ab365defd0d72ed26bc9feca9c2eb2d24">LaunchServerEvent</a> (<a class="el" href="classcelPlayer.html">celPlayer</a> *player, <a class="el" href="classcelServerEventData.html">celServerEventData</a> &amp;event_data)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">A server event has to be sent to a player.  <a href="#ab365defd0d72ed26bc9feca9c2eb2d24"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiCelGameServer.html#a478c53aaced8adb9d6fed2e7b25cb120">LaunchServerEvent</a> (<a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#gad5ecc59cce16a9f5a796b6e55da62e56">csStringID</a> channel_id, <a class="el" href="classcelServerEventData.html">celServerEventData</a> &amp;event_data)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">A server event has to be sent to the players in the channel.  <a href="#a478c53aaced8adb9d6fed2e7b25cb120"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiCelGameServer.html#a6cb6d3fd0f3820db6a4c84008f1684f5">RegisterServerManager</a> (<a class="el" href="classcelGameServerManager.html">celGameServerManager</a> *manager)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Register the manager of this server.  <a href="#a6cb6d3fd0f3820db6a4c84008f1684f5"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiCelGameServer.html#a45b7b85b7722f300a32a8e4c7f356bf6">RemoveChannel</a> (<a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#gad5ecc59cce16a9f5a796b6e55da62e56">csStringID</a> channel_id)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Stop managing the list of players and delete it.  <a href="#a45b7b85b7722f300a32a8e4c7f356bf6"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiCelGameServer.html#ae44a50920a02a43fc35ebaa31d9dfed7">RemoveNetworkLink</a> (<a class="el" href="structiCelEntity.html">iCelEntity</a> *entity, <a class="el" href="classcelPlayer.html">celPlayer</a> *player)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Remove the existing link between the entity and the player, ie the state of the entity will no more be sent to the player.  <a href="#ae44a50920a02a43fc35ebaa31d9dfed7"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiCelGameServer.html#ac75bc4e090f90c0e1847866e4b7ea0fe">RemoveNetworkLink</a> (<a class="el" href="structiCelEntity.html">iCelEntity</a> *entity, <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#gad5ecc59cce16a9f5a796b6e55da62e56">csStringID</a> channel_id)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Remove the existing link between the entity and the channel, ie the state of the entity will no more be sent to the players in the list.  <a href="#ac75bc4e090f90c0e1847866e4b7ea0fe"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiCelGameServer.html#a1eaa5e8aa5701e68c38b47d7c957ce7d">SetAdministrator</a> (<a class="el" href="classcelPlayer.html">celPlayer</a> *new_admin)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Set the administrator of the game.  <a href="#a1eaa5e8aa5701e68c38b47d7c957ce7d"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiCelGameServer.html#a6c28d9004097fe7023cd4af82a10e213">SetClientTimeOut</a> (<a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#ga28e82998c4c2d1197a1d412bba7da793">csTicks</a> timeout)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">The server will consider a client connected until the connection is broken (network state CEL_NET_PLAYER_UNREACHABLE) during the specified time.  <a href="#a6c28d9004097fe7023cd4af82a10e213"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiCelGameServer.html#ac7ca31a371cadb9d58aa1f4cd0881c30">SetMaximumBandwidth</a> (size_t width)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Specify the maximum bandwidth of the network data transmission in bytes per second.  <a href="#ac7ca31a371cadb9d58aa1f4cd0881c30"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiCelGameServer.html#aedb3d272861232091c72158d8caeeed7">SetNetworkLink</a> (<a class="el" href="classcelPlayer.html">celPlayer</a> *player, <a class="el" href="classcelNetworkLinkData.html">celNetworkLinkData</a> &amp;link_data, bool player_controlled)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Establish a link between an entity and a player.  <a href="#aedb3d272861232091c72158d8caeeed7"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiCelGameServer.html#ab1a8d420c95a4f59ee36c45d6da48c3b">SetNetworkLink</a> (<a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#gad5ecc59cce16a9f5a796b6e55da62e56">csStringID</a> channel_id, <a class="el" href="classcelNetworkLinkData.html">celNetworkLinkData</a> &amp;link_data)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Establish a link between a source entity and the players in a list.  <a href="#ab1a8d420c95a4f59ee36c45d6da48c3b"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structiCelGameServer.html#a4340ef99e77de2b0339700d4405c50dc">SetNetworkPeriod</a> (<a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#ga28e82998c4c2d1197a1d412bba7da793">csTicks</a> period)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Specify the maximum frequency at which the server can send data to clients.  <a href="#a4340ef99e77de2b0339700d4405c50dc"></a><br/></td></tr>
</table>
<hr/><a name="details" id="details"></a><h2>Detailed Description</h2>
<div class="textblock"><p>The main object to manage the server game logic. </p>
<p>You can use it to:</p>
<ul>
<li>get and set the administrator of the game, get the list of players of the game, kick a player from the game.</li>
<li>create and remove channels, ie list of players.</li>
<li>send server events, create and remove network links.</li>
<li>re-initialize a game for example when a new level is started.</li>
<li>set some options on the server.</li>
<li>get some network statistics.</li>
</ul>
<p>You should define and register a <a class="el" href="classcelGameServerManager.html" title="This is an interface you should implement in order to manage the events from the server.">celGameServerManager</a> which will catch the events from this server. </p>

<p>Definition at line <a class="el" href="network_8h_source.html#l00335">335</a> of file <a class="el" href="network_8h_source.html">network.h</a>.</p>
</div><hr/><h2>Member Function Documentation</h2>
<a class="anchor" id="a85aee2cd64948525a312287aca56cc7e"></a><!-- doxytag: member="iCelGameServer::ChangeLevel" ref="a85aee2cd64948525a312287aca56cc7e" args="(celGameInfo *new_game)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiCelGameServer.html#a85aee2cd64948525a312287aca56cc7e">iCelGameServer::ChangeLevel</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classcelGameInfo.html">celGameInfo</a> *&#160;</td>
          <td class="paramname"><em>new_game</em></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Level change, the game is re-initialized. </p>
<p>Clear all pending network links and server events. The iCelGameClientManager of all players will be called with <a class="el" href="classcelGameClientManager.html#a237ee6c3a3904eafd3d021f06558ee4b" title="The level has changed.">celGameClientManager::LevelChanged</a>. All the players are marked as CEL_NET_PLAYER_CONNECTING, they will need to do <a class="el" href="structiCelGameClient.html#abbd38fbb4892af3680c5a78ed67204c3" title="Indicate that the client has loaded everything and is ready to play.">iCelGameClient::SetReady</a>. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">level_name</td><td>a significant name for the new level. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a2226fe2e45a5ed5218fe1902cdf0952c"></a><!-- doxytag: member="iCelGameServer::ChangeLinkControl" ref="a2226fe2e45a5ed5218fe1902cdf0952c" args="(iCelEntity *entity, celPlayer *player, bool player_controlled)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiCelGameServer.html#a2226fe2e45a5ed5218fe1902cdf0952c">iCelGameServer::ChangeLinkControl</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structiCelEntity.html">iCelEntity</a> *&#160;</td>
          <td class="paramname"><em>entity</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classcelPlayer.html">celPlayer</a> *&#160;</td>
          <td class="paramname"><em>player</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>player_controlled</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Define if it is the client or the server that will update the entity. </p>
<p>A network link between the player and the entity must be present. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">entity</td><td>the entity network linked to the player </td></tr>
    <tr><td class="paramname">player</td><td>the player network linked to the entity </td></tr>
    <tr><td class="paramname">player_controlled</td><td>false if the entity is controlled by the server, true if it is by the client (ie this is the client that will update the entity and send its state to the server, instead of the contrary). </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="ad9f84d3748644041a79a77ffc52b0101"></a><!-- doxytag: member="iCelGameServer::CreateChannel" ref="ad9f84d3748644041a79a77ffc52b0101" args="(csStringID channel_id)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="structiCelPlayerList.html">iCelPlayerList</a>* <a class="el" href="structiCelGameServer.html#ad9f84d3748644041a79a77ffc52b0101">iCelGameServer::CreateChannel</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#gad5ecc59cce16a9f5a796b6e55da62e56">csStringID</a>&#160;</td>
          <td class="paramname"><em>channel_id</em></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Create a channel, ie a list of players. </p>
<p>The list will be managed by the server which will listen to players disconnecting and will so remove them from the list. Channels are useful to send the same server events or create the same network links to a list of players. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">channel_id</td><td>the ID of the channel </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a2b1eec275a973437b25f4194df7afca3"></a><!-- doxytag: member="iCelGameServer::GetAdministrator" ref="a2b1eec275a973437b25f4194df7afca3" args="()=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="classcelPlayer.html">celPlayer</a>* <a class="el" href="structiCelGameServer.html#a2b1eec275a973437b25f4194df7afca3">iCelGameServer::GetAdministrator</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Return the administrator of the game. </p>
<p>The return value can be 0 if no administrator was defined in iCelGameFactory::CreateGame. </p>

</div>
</div>
<a class="anchor" id="a48175bcad72165ff0d472a12bdad91e0"></a><!-- doxytag: member="iCelGameServer::GetNetworkPlayerStats" ref="a48175bcad72165ff0d472a12bdad91e0" args="(celPlayer *player, celNetworkPlayerStats &amp;stats) const =0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiCelGameServer.html#a48175bcad72165ff0d472a12bdad91e0">iCelGameServer::GetNetworkPlayerStats</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classcelPlayer.html">celPlayer</a> *&#160;</td>
          <td class="paramname"><em>player</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="structcelNetworkPlayerStats.html">celNetworkPlayerStats</a> &amp;&#160;</td>
          <td class="paramname"><em>stats</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td> const<code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Return the network stats of the specified player. </p>

</div>
</div>
<a class="anchor" id="af65fd31e91d224e8a7f1d031b0248f0a"></a><!-- doxytag: member="iCelGameServer::GetNetworkTotalStats" ref="af65fd31e91d224e8a7f1d031b0248f0a" args="(celNetworkPlayerTotalStats &amp;stats) const =0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiCelGameServer.html#af65fd31e91d224e8a7f1d031b0248f0a">iCelGameServer::GetNetworkTotalStats</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structcelNetworkPlayerTotalStats.html">celNetworkPlayerTotalStats</a> &amp;&#160;</td>
          <td class="paramname"><em>stats</em></td><td>)</td>
          <td> const<code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Return the network stats of this server. </p>

</div>
</div>
<a class="anchor" id="ac664ae438691d8e81ab1eca933ac8ddf"></a><!-- doxytag: member="iCelGameServer::GetPlayerList" ref="ac664ae438691d8e81ab1eca933ac8ddf" args="()=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="structiCelPlayerList.html">iCelPlayerList</a>* <a class="el" href="structiCelGameServer.html#ac664ae438691d8e81ab1eca933ac8ddf">iCelGameServer::GetPlayerList</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Return the list of players connected to the server. </p>

</div>
</div>
<a class="anchor" id="a1fdd2b3ad82217d20ff4ab1e32e9ae00"></a><!-- doxytag: member="iCelGameServer::GetPlayerState" ref="a1fdd2b3ad82217d20ff4ab1e32e9ae00" args="(celPlayer *player)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual celPlayerNetworkState <a class="el" href="structiCelGameServer.html#a1fdd2b3ad82217d20ff4ab1e32e9ae00">iCelGameServer::GetPlayerState</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classcelPlayer.html">celPlayer</a> *&#160;</td>
          <td class="paramname"><em>player</em></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Return the state of the network connection to the player. </p>

</div>
</div>
<a class="anchor" id="afbad5b793a8dfffbb3a804cdb61003de"></a><!-- doxytag: member="iCelGameServer::KickPlayer" ref="afbad5b793a8dfffbb3a804cdb61003de" args="(celPlayer *player, const char *reason)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiCelGameServer.html#afbad5b793a8dfffbb3a804cdb61003de">iCelGameServer::KickPlayer</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classcelPlayer.html">celPlayer</a> *&#160;</td>
          <td class="paramname"><em>player</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>reason</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Kick the player from the game, ie the player will be forced to disconnect from the game. </p>
<p>A text explaining the reason can be specified. </p>

</div>
</div>
<a class="anchor" id="ab365defd0d72ed26bc9feca9c2eb2d24"></a><!-- doxytag: member="iCelGameServer::LaunchServerEvent" ref="ab365defd0d72ed26bc9feca9c2eb2d24" args="(celPlayer *player, celServerEventData &amp;event_data)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiCelGameServer.html#ab365defd0d72ed26bc9feca9c2eb2d24">iCelGameServer::LaunchServerEvent</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classcelPlayer.html">celPlayer</a> *&#160;</td>
          <td class="paramname"><em>player</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classcelServerEventData.html">celServerEventData</a> &amp;&#160;</td>
          <td class="paramname"><em>event_data</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>A server event has to be sent to a player. </p>

</div>
</div>
<a class="anchor" id="a478c53aaced8adb9d6fed2e7b25cb120"></a><!-- doxytag: member="iCelGameServer::LaunchServerEvent" ref="a478c53aaced8adb9d6fed2e7b25cb120" args="(csStringID channel_id, celServerEventData &amp;event_data)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiCelGameServer.html#ab365defd0d72ed26bc9feca9c2eb2d24">iCelGameServer::LaunchServerEvent</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#gad5ecc59cce16a9f5a796b6e55da62e56">csStringID</a>&#160;</td>
          <td class="paramname"><em>channel_id</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classcelServerEventData.html">celServerEventData</a> &amp;&#160;</td>
          <td class="paramname"><em>event_data</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>A server event has to be sent to the players in the channel. </p>

</div>
</div>
<a class="anchor" id="a6cb6d3fd0f3820db6a4c84008f1684f5"></a><!-- doxytag: member="iCelGameServer::RegisterServerManager" ref="a6cb6d3fd0f3820db6a4c84008f1684f5" args="(celGameServerManager *manager)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiCelGameServer.html#a6cb6d3fd0f3820db6a4c84008f1684f5">iCelGameServer::RegisterServerManager</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classcelGameServerManager.html">celGameServerManager</a> *&#160;</td>
          <td class="paramname"><em>manager</em></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Register the manager of this server. </p>
<p>Only one manager can be registered at a time. </p>

</div>
</div>
<a class="anchor" id="a45b7b85b7722f300a32a8e4c7f356bf6"></a><!-- doxytag: member="iCelGameServer::RemoveChannel" ref="a45b7b85b7722f300a32a8e4c7f356bf6" args="(csStringID channel_id)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiCelGameServer.html#a45b7b85b7722f300a32a8e4c7f356bf6">iCelGameServer::RemoveChannel</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#gad5ecc59cce16a9f5a796b6e55da62e56">csStringID</a>&#160;</td>
          <td class="paramname"><em>channel_id</em></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Stop managing the list of players and delete it. </p>
<p>Any existing network links to this channel will also be removed. </p>

</div>
</div>
<a class="anchor" id="ae44a50920a02a43fc35ebaa31d9dfed7"></a><!-- doxytag: member="iCelGameServer::RemoveNetworkLink" ref="ae44a50920a02a43fc35ebaa31d9dfed7" args="(iCelEntity *entity, celPlayer *player)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiCelGameServer.html#ae44a50920a02a43fc35ebaa31d9dfed7">iCelGameServer::RemoveNetworkLink</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structiCelEntity.html">iCelEntity</a> *&#160;</td>
          <td class="paramname"><em>entity</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classcelPlayer.html">celPlayer</a> *&#160;</td>
          <td class="paramname"><em>player</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Remove the existing link between the entity and the player, ie the state of the entity will no more be sent to the player. </p>

</div>
</div>
<a class="anchor" id="ac75bc4e090f90c0e1847866e4b7ea0fe"></a><!-- doxytag: member="iCelGameServer::RemoveNetworkLink" ref="ac75bc4e090f90c0e1847866e4b7ea0fe" args="(iCelEntity *entity, csStringID channel_id)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiCelGameServer.html#ae44a50920a02a43fc35ebaa31d9dfed7">iCelGameServer::RemoveNetworkLink</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structiCelEntity.html">iCelEntity</a> *&#160;</td>
          <td class="paramname"><em>entity</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#gad5ecc59cce16a9f5a796b6e55da62e56">csStringID</a>&#160;</td>
          <td class="paramname"><em>channel_id</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Remove the existing link between the entity and the channel, ie the state of the entity will no more be sent to the players in the list. </p>

</div>
</div>
<a class="anchor" id="a1eaa5e8aa5701e68c38b47d7c957ce7d"></a><!-- doxytag: member="iCelGameServer::SetAdministrator" ref="a1eaa5e8aa5701e68c38b47d7c957ce7d" args="(celPlayer *new_admin)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiCelGameServer.html#a1eaa5e8aa5701e68c38b47d7c957ce7d">iCelGameServer::SetAdministrator</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classcelPlayer.html">celPlayer</a> *&#160;</td>
          <td class="paramname"><em>new_admin</em></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Set the administrator of the game. </p>
<p>It doesn't need to be a player already connected. </p>

</div>
</div>
<a class="anchor" id="a6c28d9004097fe7023cd4af82a10e213"></a><!-- doxytag: member="iCelGameServer::SetClientTimeOut" ref="a6c28d9004097fe7023cd4af82a10e213" args="(csTicks timeout)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiCelGameServer.html#a6c28d9004097fe7023cd4af82a10e213">iCelGameServer::SetClientTimeOut</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#ga28e82998c4c2d1197a1d412bba7da793">csTicks</a>&#160;</td>
          <td class="paramname"><em>timeout</em></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>The server will consider a client connected until the connection is broken (network state CEL_NET_PLAYER_UNREACHABLE) during the specified time. </p>

</div>
</div>
<a class="anchor" id="ac7ca31a371cadb9d58aa1f4cd0881c30"></a><!-- doxytag: member="iCelGameServer::SetMaximumBandwidth" ref="ac7ca31a371cadb9d58aa1f4cd0881c30" args="(size_t width)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiCelGameServer.html#ac7ca31a371cadb9d58aa1f4cd0881c30">iCelGameServer::SetMaximumBandwidth</a> </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>width</em></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Specify the maximum bandwidth of the network data transmission in bytes per second. </p>
<p>A bandwidth of 0 means that it is unlimited. </p>

</div>
</div>
<a class="anchor" id="aedb3d272861232091c72158d8caeeed7"></a><!-- doxytag: member="iCelGameServer::SetNetworkLink" ref="aedb3d272861232091c72158d8caeeed7" args="(celPlayer *player, celNetworkLinkData &amp;link_data, bool player_controlled)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiCelGameServer.html#aedb3d272861232091c72158d8caeeed7">iCelGameServer::SetNetworkLink</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classcelPlayer.html">celPlayer</a> *&#160;</td>
          <td class="paramname"><em>player</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classcelNetworkLinkData.html">celNetworkLinkData</a> &amp;&#160;</td>
          <td class="paramname"><em>link_data</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>player_controlled</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Establish a link between an entity and a player. </p>
<p>When a link is set up, a copy entity will be created on the client side and the server manager will send periodically a part of the state of the entity to the copy entity. </p>
<p>If the entity is controlled on the client side, the network link will be in the other direction and the state of the entity will be sent periodically from the client side to the server side. </p>
<p>If a link between the entity and the player is already present, the previous link will be removed. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">player</td><td>the player linked to the entity </td></tr>
    <tr><td class="paramname">link_data</td><td>the data of the network link </td></tr>
    <tr><td class="paramname">player_controlled</td><td>false if the entity is controlled by the server, true if it is by the client (ie this is the client that will update the entity and send its state to the server, instead of the contrary). </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="ab1a8d420c95a4f59ee36c45d6da48c3b"></a><!-- doxytag: member="iCelGameServer::SetNetworkLink" ref="ab1a8d420c95a4f59ee36c45d6da48c3b" args="(csStringID channel_id, celNetworkLinkData &amp;link_data)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiCelGameServer.html#aedb3d272861232091c72158d8caeeed7">iCelGameServer::SetNetworkLink</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#gad5ecc59cce16a9f5a796b6e55da62e56">csStringID</a>&#160;</td>
          <td class="paramname"><em>channel_id</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classcelNetworkLinkData.html">celNetworkLinkData</a> &amp;&#160;</td>
          <td class="paramname"><em>link_data</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Establish a link between a source entity and the players in a list. </p>
<p>When a link is set up, a copy entity will be created on each client side and the server manager will send periodically a part of the state of the entity to the copy entity. </p>
<p>If a link between the entity and the channel is already present, the previous link will be removed. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">channel_id</td><td>the ID of the channel </td></tr>
    <tr><td class="paramname">link_data</td><td>the data of the network link </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a4340ef99e77de2b0339700d4405c50dc"></a><!-- doxytag: member="iCelGameServer::SetNetworkPeriod" ref="a4340ef99e77de2b0339700d4405c50dc" args="(csTicks period)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="structiCelGameServer.html#a4340ef99e77de2b0339700d4405c50dc">iCelGameServer::SetNetworkPeriod</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#ga28e82998c4c2d1197a1d412bba7da793">csTicks</a>&#160;</td>
          <td class="paramname"><em>period</em></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Specify the maximum frequency at which the server can send data to clients. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">period</td><td>the number of ticks between two updates from the server. A period of 0 means "as soon as possible". </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<hr/>The documentation for this struct was generated from the following file:<ul>
<li>physicallayer/<a class="el" href="network_8h_source.html">network.h</a></li>
</ul>
</div><!-- contents -->
<hr size="1"><address><small>Generated for CEL: Crystal Entity Layer 2.0 by 
<a href="http://www.doxygen.org/index.html">doxygen</a> 1.7.6.1 
</small></address> </div></body> </html>
